<?php
/*
 * The config file used with Waggies Weather.
 * Copyright for this package of code: https://waggies.net/ws/copyright.txt.
 * Customise lines marked *** to your needs.
 */

$thisYear = '2019';

class WsConfig {
    //data
    // yes, this could be more generalised
    public $kensId = 'xxx'; // ***
    public $petesId = 'xxxyx';  // ***

    public $nameIndex = 0;  // default index
    public $names = array('Waggies', 'Petes');  //***
    public $locations = array('Craigburn Farm, South Australia',    // ***
                              'Morgan, South Australia');
    public $locale = 'Australia/Adelaide';  // ***

    public $onMobile = false;

    //DB
    public $dbhost = 'localhost';
    public $dbname = 'waggies_ws';  // ***
    public $dbtablenames = array('waggies', 'pete');    // ***
    public $dbtablename = 'waggies';    // ***
    public $dbpassword = 'xxx';  // ***

    public $showInside = false;
    public $authCookie = 'insider';
    public $authPassword = 'xxx';       // ***


    public function saveInsideAuth($pwd) {
        $hash = password_hash($pwd, PASSWORD_DEFAULT);
        //setrawcookie($cfg->authCookie, $hash, time() + 3600*24*365, 'https://waggies/ws/'); // a year  // ***
        setcookie($this->authCookie, $hash, time() + 3600*24*365, '/'); // a year
    }


    public function getInsideAuth() {
        if (isset($_COOKIE[$this->authCookie])) {
            $this->showInside = password_verify($this->authPassword, $_COOKIE[$this->authCookie]);
        }
        return $this->showInside;
    }

}
