<?php
/*
 * WEATHER GRAPHS PAGE
 * This page draws weather graphs using Google Charts.
 * Copyright for this package of code: https://waggies.net/ws/copyright.txt.
 */
include "./classes/Db.php"; // this includes the config
$cfg = new WsConfig();
$showInside = $cfg->getInsideAuth();

$useragent = $_SERVER['HTTP_USER_AGENT'];
$cfg->onMobile = (preg_match('/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i',$useragent)||preg_match('/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i',substr($useragent,0,4)));
$who = isset($_GET['who']) ? $_GET['who'] : 'Ken';
$who = strtolower($who);
$cfg->nameIndex = (isset($who) && ($who === 'pete' || $who === 'petes')) ? 1 : 0;
$who = $cfg->names[$cfg->nameIndex];
$location = $cfg->locations[$cfg->nameIndex];

//$cfg->dbtablename = $cfg->dbtablenames[$cfg->nameIndex];
$cfg->dbtablename = $cfg->dbtablenames[0];

date_default_timezone_set($cfg->locale);
$timenow = strftime('%G-%m-%d %H:%M:%S');

$fetch = 289;  // default to a day, go back 288 entries (could/should use the timestamp)
$period = 'daily';
//$rainIndex = 'raindaily';
$linkText = '';
if (isset($_GET['week'])) {
    $fetch = 288 * 7 + 1;
    $period = 'weekly';
    //$rainIndex = 'rainweekly';
    $linkText = "<a href='./ggraphs.php?who=$who'>Daily</a>";
}
else {
    $linkText = "<a href='./ggraphs.php?who=$who&week'>Weekly</a>";
}
$interval = ($fetch < 300) ? 1 : 7; // number of skips between elements


// get the DB connection
$db = new Db();
$rows = $db->fetchLastN($cfg, $fetch);
$rows = array_reverse($rows);
$db = null;

$dataTemperature = '';
$dataHumidity = '';
$dataPressure = '';
$dataWind = '';
$dataWindDirn = '';
$dataRain = '';
$dataLight = '';

// show graphs

$rainBase = $rows[0]['raintotal'];
$maxGust = 0;

foreach($rows as $i => $vals) {
    if ($vals['windgust'] > $maxGust) {
        $maxGust = $vals['windgust'];
    }
    if($interval > 1 && ($i % $interval) > 0) {
        continue; // drop some values
    }
    $timestamp = $vals['timestamp'];
    $dateStr = "new Date('$timestamp')";
    $rain = $vals['raintotal'] - $rainBase;
    if ($showInside) {
        $dataTemperature .= "[$dateStr,${vals['tempin']},${vals['temp']}],";
        $dataHumidity .= "[$dateStr,${vals['humidityin']},${vals['humidity']}],";
    }
    else {
        $dataTemperature .= "[$dateStr,${vals['temp']}],";
        $dataHumidity .= "[$dateStr,${vals['humidity']}],";
    }
    $dataPressure .= "[$dateStr,${vals['baromrel']}],";
    $dataWind .= "[$dateStr,${vals['windspeed']},$maxGust],";
    $maxGust = 0;
    $dataWindDirn .= "[$dateStr,${vals['winddir']}],";
//    $dataRain .= "[$dateStr,${vals[$rainIndex]},${vals['rainrate']}],";
    $dataRain .= "[$dateStr,$rain,${vals['rainrate']}],";
    $dataLight .= "[$dateStr,${vals['solarradiation']}],";
}
//print ("data = '$data'<br>");

?>
<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<meta name="author" content="Ken Wagnitz">
<!-- Copyright for this package of code: https://waggies.net/ws/copyright.txt. -->

<title>Waggies Graphs</title>
    <style type="text/css">
    body {
        text-align: center;
        /* font-size: 150%; */
        font-weight: normal;
    }
    h2 {
        margin: 0px;
        color: #800080;
    }
    </style>
	<script type="text/javascript" src="https://www.gstatic.com/charts/loader.js"></script>
	<script type="text/javascript">
  	google.charts.load('current', {packages: ['corechart']});
  	google.charts.setOnLoadCallback(drawCharts);

      function drawCharts() {
          var dataTemperature = google.visualization.arrayToDataTable([
        	  <?php
        	  print($showInside ? "['Time', 'Indoor', 'Outdoor'],"
        	                    : "['Time', 'Temperature']," );
              ?>
              <?=$dataTemperature?>
            ]);
          var dataHumidity = google.visualization.arrayToDataTable([
        	  <?php
        	  print($showInside ? "['Time', 'Indoor', 'Outdoor'],"
        	                    : "['Time', 'Humidity']," );
                      ?>
              <?=$dataHumidity?>
            ]);
          var dataPressure = google.visualization.arrayToDataTable([
              ['Time', 'Pressure'],
              <?=$dataPressure?>
            ]);
          var dataRain = google.visualization.arrayToDataTable([
              ['Time', 'Rain', 'Rain rate'],
              <?=$dataRain?>
            ]);
          var dataWind = google.visualization.arrayToDataTable([
              ['Time', 'Wind', 'Wind gust'],
              <?=$dataWind?>
            ]);
          var dataWindDirn = google.visualization.arrayToDataTable([
              ['Time', 'Wind direction'],
              <?=$dataWindDirn?>
            ]);
          var dataLight = google.visualization.arrayToDataTable([
              ['Time', 'Light intensity'],
              <?=$dataLight?>
            ]);

          var optionsTemperature = {
                  title: 'Temperature - degrees C',
                  //curveType: 'function',
                  legend: { position: 'top' },
                  hAxis: {
                      gridlines: {
                          count: -1,
                          units: { days: {format: ['EEE']} }
                      }
                  },
                  //vAxis: { title: 'Temperature in degrees C',
                //	  titleTextStyle: 'padding: 0px;'},
                };
          var optionsHumidity = {
                  title: 'Humidity - %',
                  legend: { position: 'top' },
                  hAxis: {
                      gridlines: {
                          count: -1,
                          units: { days: {format: ['EEE']} }
                      }
                  },
                  //vAxis: { title: 'Humidity %' }
                };
          var optionsPressure = {
                  title: 'Atmospheric pressure - hPa',
                  legend: 'none',
                  hAxis: {
                      gridlines: {
                          count: -1,
                          units: { days: {format: ['EEE']} }
                      }
                  },
                  //vAxis: { title: 'Pressure in hPa' }
                };
          var optionsRain = {
                  title: 'Rain <?=$period?>, rain rate - mm, mm/h',
                  legend: { position: 'top' },
                  hAxis: {
                      gridlines: {
                          count: -1,
                          units: { days: {format: ['EEE']} }
                      }
                  },
                  //vAxis: { title: 'Rain in mm, rain rate in mm/h' }
                  vAxis: { viewWindow: { min: 0 } }
                };
          var optionsWind = {
                  title: 'Wind, wind gust - km/h',
                  legend: { position: 'top' },
                  hAxis: {
                      gridlines: {
                          count: -1,
                          units: { days: {format: ['EEE']} }
                      }
                  },
                  //vAxis: { title: 'Wind speed and gust in km/h' }
                };
          var optionsWindDirn = {
                  title: 'Wind direction - degrees',
                  legend: 'none',
                  hAxis: {
                      gridlines: {
                          count: -1,
                          units: { days: {format: ['EEE']} }
                      }
                  },
                  //vAxis: { maxValue: 360 }
                  vAxis: { viewWindow: { max: 360 } }
                };
          var optionsLight = {
                  title: 'Light intensity - watts per square metre',
                  legend: 'none',
                  hAxis: {
                      gridlines: {
                          count: -1,
                          units: { days: {format: ['EEE']} }
                      }
                  },
                };

        var chartTemperature = new google.visualization.LineChart(document.getElementById('chartTemperature'));
        chartTemperature.draw(dataTemperature, optionsTemperature);
        var chartHumidity = new google.visualization.LineChart(document.getElementById('chartHumidity'));
        chartHumidity.draw(dataHumidity, optionsHumidity);
        var chartPressure = new google.visualization.LineChart(document.getElementById('chartPressure'));
        chartPressure.draw(dataPressure, optionsPressure);
        var chartRain = new google.visualization.LineChart(document.getElementById('chartRain'));
        chartRain.draw(dataRain, optionsRain);
        var chartWind = new google.visualization.LineChart(document.getElementById('chartWind'));
        chartWind.draw(dataWind, optionsWind);
        var chartWindDirn = new google.visualization.ScatterChart(document.getElementById('chartWindDirn'));
        chartWindDirn.draw(dataWindDirn, optionsWindDirn);
        var chartLight = new google.visualization.LineChart(document.getElementById('chartLight'));
        chartLight.draw(dataLight, optionsLight);
      }
    </script>
  </head>
  <body>
	<h2><?=$who?> weather <?=$period?> graphs as at <?=$timenow?></h2>
  	From <?=$location?>. &nbsp;&nbsp;&nbsp;<a href='./index.php?who=<?=$who?>'><b>Home</b></a>&nbsp;&nbsp;&nbsp;<?=$linkText?>

    <div id="chartTemperature" style="height: 500px"></div>
    <div id="chartHumidity" style="height: 500px"></div>
    <div id="chartPressure" style="height: 500px"></div>
    <div id="chartRain" style="height: 500px"></div>
    <div id="chartWind" style="height: 500px"></div>
    <div id="chartWindDirn" style="height: 500px"></div>
    <div id="chartLight" style="height: 500px"></div>
  </body>
</html>
