<?php
/*
 * WEATHER GRAPHS PAGE
 * An include for drawing weather graphs using chartjs.
 * Copyright for this package of code: https://waggies.net/ws/copyright.txt.
 */
?>
<div class="chartjs-wrapper"  style="width:75%; margin-left:auto; margin-right:auto;">
<canvas id="temperature" class="chartjs" width="undefined" height="undefined"></canvas>
<script>
new Chart(document.getElementById("temperature"), {
	"type":"line",
	"data":{
		"labels":[<?=$labels?>],
		"datasets":
		[{
			"label":"Temperature outdoors",
			"data":[<?=$temppointsout?>],
			"fill":false,
			"borderColor":"rgb(255, 192, 192)",
			"lineTension":0
			},
			<?php if ($showInside) { ?>
			{
				"label":"Temperature indoors",
				"data":[<?=$temppointsin?>],
				"fill":false,
				"borderColor":"rgb(75, 192, 192)",
				"lineTension":0
			}
			<?php } ?>
		]},
		"options":{
			title: {
				display: true,
				<?php if ($showInside) { ?>
					text: 'Outdoor and Indoor Temperatures'
				<?php } else { ?>
					text: 'Outdoor Temperature'
				<?php } ?>
			},
			responsive: true,
		    scales:{
		        xAxes:[{
					scaleLabel: {
						display: true,
						labelString: 'The last 24 hours'
					},
					ticks: {
						callback: function(dataLabel, index) {
							// Show the label of every 12th dataset. return null to hide the grid line too
							return index % 12 === 0 ? dataLabel : '';
						}
					}
		        }],
    			yAxes:[{
    				display: true,
    				scaleLabel: {
    					display: true,
    					labelString: 'Temperature degrees C'
    				},
    			}]
			}
		}
	});
</script></div>
<br><br>

<div class="chartjs-wrapper"  style="width:75%; margin-left:auto; margin-right:auto;">
<canvas id="humidity" class="chartjs" width="undefined" height="undefined"></canvas>
<script>
new Chart(document.getElementById("humidity"), {
	"type":"line",
	"data":{
		"labels":[<?=$labels?>],
		"datasets":
		[{
			"label":"Humidity outdoors",
			"data":[<?=$humpointsout?>],
			"fill":false,
			"borderColor":"rgb(255, 192, 192)",
			"lineTension":0
			},
			<?php if ($showInside) { ?>
			{
				"label":"Humidity indoors",
				"data":[<?=$humpointsin?>],
				"fill":false,
				"borderColor":"rgb(75, 192, 192)",
				"lineTension":0
			}
			<?php } ?>
		]},
		"options":{
			title: {
				display: true,
				<?php if ($showInside) { ?>
					text: 'Outdoor and Indoor Humidities'
				<?php } else { ?>
				text: 'Outdoor Humidity'
				<?php } ?>
			},
			responsive: true,
		    scales:{
		        xAxes:[{
					scaleLabel: {
						display: true,
						labelString: 'The last 24 hours'
					},
					ticks: {
						callback: function(dataLabel, index) {
							// Show the label of every 12th dataset. return null to hide the grid line too
							return index % 12 === 0 ? dataLabel : '';
						}
					}
		        }],
    			yAxes:[{
    				display: true,
    				scaleLabel: {
    					display: true,
    					labelString: 'Humidity %'
    				},
    			}]
			}
		}
	});
</script></div>
<br><br>

<div class="chartjs-wrapper"  style="width:75%; margin-left:auto; margin-right:auto;">
<canvas id="pressure" class="chartjs" width="undefined" height="undefined"></canvas>
<script>
new Chart(document.getElementById("pressure"), {
	"type":"line",
	"data":{
		"labels":[<?=$labels?>],
		"datasets":[{
			"label":"Atmospheric pressure",
			"data":[<?=$presspoints?>],
			"fill":false,
			"borderColor":"rgb(75, 255, 75)",
			"lineTension":0
			}
		]},
		"options":{
			title: {
				display: true,
				text: 'Atmospheric Pressure'
			},
			responsive: true,
		    scales:{
		        xAxes:[{
					scaleLabel: {
						display: true,
						labelString: 'The last 24 hours'
					},
					ticks: {
						callback: function(dataLabel, index) {
							// Show the label of every 12th dataset. return null to hide the grid line too
							return index % 12 === 0 ? dataLabel : '';
						}
					}
		        }],
    			yAxes:[{
    				display: true,
    				scaleLabel: {
    					display: true,
    					labelString: 'Atmospheric Pressure hPa'
    				},
    			}]
			}
		}
	});
</script></div>
<br><br>

<div class="chartjs-wrapper"  style="width:75%; margin-left:auto; margin-right:auto;">
<canvas id="windspeed" class="chartjs" width="undefined" height="undefined"></canvas>
<script>
new Chart(document.getElementById("windspeed"), {
	"type":"line",
	"data":{
		"labels":[<?=$labels?>],
		"datasets":[{
			"label":"Wind speed",
			"data":[<?=$windpoints?>],
			"fill":false,
			"borderColor":"rgb(75, 75, 255)",
			"lineTension":0
			},{
				"label":"Wind gust",
				"data":[<?=$gustpoints?>],
				"fill":false,
				"borderColor":"rgb(255, 75, 755)",
				"lineTension":0
				}
		]},
		"options":{
			title: {
				display: true,
				text: 'Wind Speed'
			},
			responsive: true,
		    scales:{
		        xAxes:[{
					scaleLabel: {
						display: true,
						labelString: 'The last 24 hours'
					},
					ticks: {
						callback: function(dataLabel, index) {
							// Show the label of every 12th dataset. return null to hide the grid line too
							return index % 12 === 0 ? dataLabel : '';
						}
					}
		        }],
    			yAxes:[{
    				display: true,
    				scaleLabel: {
    					display: true,
    					labelString: 'Wind speed & Gust km/h'
    				},
    			}]
			}
		}
	});
</script></div>
<br><br>

<div class="chartjs-wrapper"  style="width:75%; margin-left:auto; margin-right:auto;">
<canvas id="rain" class="chartjs" width="undefined" height="undefined"></canvas>
<script>
new Chart(document.getElementById("rain"), {
	"type":"line",
	"data":{
		"labels":[<?=$labels?>],
		"datasets":[{
			"label":"Rain",
			"data":[<?=$raindailypoints?>],
			"fill":false,
			"borderColor":"rgb(75, 75, 255)",
			"lineTension":0
			},{
				"label":"Rain rate",
				"data":[<?=$rainratepoints?>],
				"fill":false,
				"borderColor":"rgb(255, 75, 755)",
				"lineTension":0
				}
		]},
		"options":{
			title: {
				display: true,
				text: 'Rain'
			},
			responsive: true,
		    scales:{
		        xAxes:[{
					scaleLabel: {
						display: true,
						labelString: 'The last 24 hours'
					},
					ticks: {
						callback: function(dataLabel, index) {
							// Show the label of every 12th dataset. return null to hide the grid line too
							return index % 12 === 0 ? dataLabel : '';
						}
					}
		        }],
    			yAxes:[{
    				display: true,
    				scaleLabel: {
    					display: true,
    					labelString: 'Rain in mm, Rain Rate in mm/h'
    				},
    			}]
			}
		}
	});
</script></div>
