<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>Waggies Graphs</title>

<script src="../js/chartjs/Chart.min.js"></script>
<script src="../js/chartjs/utils.js"></script>

</head>
<body>
<?php
/*
 * WEATHER GRAPHS PAGE
 * draws weather graphs using chartjs.
 * Copyright for this package of code: https://waggies.net/ws/copyright.txt.
 */

include "./classes/Db.php"; // this includes the config
$cfg = new WsConfig();

// get the DB connection
$db = new Db();
$rows = $db->fetchLastN($cfg, 289);  // for a day go back 288 entries
$rows = array_reverse($rows);

//print_r($rows);

$db = null;

$temppointsout = '';
$temppointsin = '';
$humpointsout = '';
$humpointsin = '';
$presspoints = '';
$windpoints = '';
$gustpoints = '';
$raindailypoints = '';
$rainratepoints = '';
$labels = "";

// show daily graphs

$rainBase = $rows[0]['raintotal'];

foreach($rows as $i => $vals) {
    $timestamp = $vals['timestamp'];
    $xlabel = substr($timestamp, 11);
    $labels .= "'$xlabel',";

    $prefix = "{x:$i,y:";
    $tempout = $vals['temp'];
    $tempin = $vals['tempin'];
    //$temppointsout .= "{x:$i,y:$tempout},";
    $temppointsout .= $prefix . $vals['temp'] . '},';
    //$temppointsin .= "{x:$i,y:$tempin},";
    $temppointsin .= $prefix . $vals['tempin'] . '},';
    $humpointsout .= $prefix . $vals['humidity'] . '},';
    $humpointsin .= $prefix . $vals['humidityin'] . '},';
    $presspoints .= $prefix . $vals['baromabs'] . '},';
    $windpoints .= $prefix . $vals['windspeed'] . '},';
    $gustpoints .= $prefix . $vals['windgust'] . '},';
    $rain = $vals['raintotal'] - $rainBase;
    $raindailypoints .= $prefix . $rain . '},';
    $rainratepoints .= $prefix . $vals['rainrate'] . '},';
}

$showInside = $cfg->getInsideAuth();
include 'graphs.inc';
?>

<br><br>

</body>
</html>



