<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<meta name="author" content="Ken Wagnitz">
<!-- Copyright for this package of code: https://waggies.net/ws/copyright.txt. -->

<title>Waggies Weather</title>

<style type="text/css">
body {
    background: #c0ffc0;
    text-align: center;
    font-size: 300%;
    font-weight: normal;
}
h2 {
    margin: 0px;
}
table {
    margin-left:auto;
    margin-right:auto;
    border: 1px solid black;
}
th {
    color: #000080;
    padding: 4px;
    border: 1px solid black;
}
td {
    color: #c00000;
    font-weight: bold;
    padding: 4px;
    border: 1px solid black;
}

/* Tooltip container */
.tooltip {
  position: relative;
  display: inline-block;
  border-bottom: 1px dotted black; /* If you want dots under the hoverable text */
}
/* Tooltip text */
.tooltip .tooltiptext {
  visibility: hidden;
  /* width: 120px; */
  background-color: black;
  color: #fff;
  text-align: center;
  padding: 10px;
  border-radius: 6px;

  /* Position the tooltip text */
  position: absolute;
  z-index: 1;
}
/* Show the tooltip text on mousing over the tooltip container */
.tooltip:hover .tooltiptext {
  visibility: visible;
}

</style>

</head>
<body>

<h2><?=$who?> Weather</h2>
&nbsp;As at <?=$row['timestamp']?> (m)<br>

<table>
<?php if ($showInside) { ?>
	<tr><th></th><th>Outside</th>
    <th>Inside</th></tr>
<?php } ?>
<tr><th>Temperature</th><td><?=$row['temp']?> <sup>o</sup>C</td>
<?php if ($showInside) { ?>
	<td><?=$row['tempin']?> <sup>o</sup>C</td>
<?php } ?>
</tr>
<tr><th>Humidity</th><td><?=$row['humidity']?> %</td>
<?php if ($showInside) { ?>
	<td><?=$row['humidityin']?> %</td>
<?php } ?>
</tr>
</table>
<table>
<tr><th>Pressure</th><td><?=$row['baromrel']?> hPa</td></tr>
<tr><th>Wind speed</th><td><?=$row['windspeed']?> km/h</td></tr>
<tr><th>Wind gust</th><td><?=$row['windgust']?> km/h</td></tr>
<tr><th>Wind gust max</th><td><?=$row['maxdailygust']?> km/h</td></tr>
<tr><th>Wind direction</th><td><?=$row['winddir']?> deg.</td></tr>
<tr><th><div class="tooltip">Rain hour<span class="tooltiptext">Rain in the last hour</span></div></th><td><?=$row['rainhourly']?> mm</td></tr>
<tr><th><div class="tooltip">Rain day<span class="tooltiptext">Rain since midnight</span></div></th><td><?=$row['raindaily']?> mm</td></tr>
<tr><th><div class="tooltip">Rain week<span class="tooltiptext">Rain since the beginning of this week</span></div></th><td><?=$row['rainweekly']?> mm</td></tr>
<tr><th><div class="tooltip">Rain month<span class="tooltiptext">Rain since the beginning of this month</span></div></th><td><?=$row['rainmonthly']?> mm</td></tr>
<!-- <tr><th>Rain total</th><td><?=$row['raintotal']?> mm</td></tr> -->
<tr><th><div class="tooltip">Light<span class="tooltiptext">Radiant flux in watts per square metre</span></div></th><td><?=$row['solarradiation']?> W/m<sup>2</sup></td></tr>
<tr><th>UV Index</th><td><?=$row['uv']?></td></tr>
</table>
<a href="./ggraphs.php?who=<?=$who?>">Daily</a>&nbsp;&nbsp;
<a href="./ggraphs.php?who=<?=$who?>&week">Weekly</a>&nbsp;&nbsp;
<a href="./about.htm">About</a><br>
<p>This weather data comes to you from <?=$location?>.</p>

</body>
</html>
