<?php
/*
 * WEATHER REPORT PAGE
 * This page adds data to the database if its in $_POST.
 *
 * $Id: $
 * $URL: $
 */
$classes = realpath(dirname(__FILE__) . '/../classes');
include_once "$classes/Db.php"; // this includes the config
$cfg = new WsConfig();

if(isset($_POST) && !empty($_POST)) {
    if ($_POST['PASSKEY'] === $cfg->kensId) {
        $cfg->nameIndex = 0;    // Ken's WS
        $cfg->dbtablename = $cfg->dbtablenames[0];
        saveData($cfg);
    }
    elseif ($_POST['PASSKEY'] === $cfg->petesId) {
        $cfg->nameIndex = 1;    // Pete's WS
        $cfg->dbtablename = $cfg->dbtablenames[1];
        saveData($cfg);
    }
    else {
        // got a spurious passkey -log an error
        showData($cfg);
    }
}
else {
    showData($cfg);
}


function saveData($cfg) {
    // write data to a file
    date_default_timezone_set($cfg->locale);
    $timestamp = strftime('%G-%m-%d %H:%M:%S');
    $pageprefix = "</body>\n</html>\n<p>Time: $timestamp </p>\n";

    $data = convertEcowitt($cfg, $_REQUEST);
    $data['timestamp'] = $timestamp;

    saveToDB($cfg, $data);

    $page = $pageprefix . '<p>Metric data:<br><br>';
    $str = '';
    // $page .= print_r($data, TRUE) . '</p>' . "\n";
    foreach($data as $key => $val) {
        $page .= "$key = $val<br>\n";
        $str .= "$key=$val\n";
    }
    $page .= "</p></body>\n</html>";

    // save the data for reading into the simple view
    $fh = fopen('./datam' . $cfg->nameIndex . '.txt', 'w');
    fwrite($fh, $str);
    fclose($fh);

    // write to Pete's file until he gets a WS
    $fh = fopen('./datam1.txt', 'w');
    fwrite($fh, $str);
    fclose($fh);

    // uncomment to have a look at the raw received data
//      $page = $pageprefix . '<p>GET = ' . print_r($_GET, TRUE) . '</p>' . "\n";
//      $page .= '<p>POST = ' . print_r($_POST, TRUE) . '</p>' . "\n";
//      $page .= "</body>\n</html>";
//      $fh = fopen('./data' . $cfg->nameIndex . '.htm', 'w');
//      fwrite($fh, $page);
//      fclose($fh);


    // uncomment to have a look at the metricated saved data
//     $fh = fopen('./datam' . $cfg->nameIndex . '.htm', 'w');
//     fwrite($fh, $page);
//     fclose($fh);
}


function saveToDB($cfg, $data) {

    $data['user'] = $cfg->nameIndex;

    date_default_timezone_set($cfg->locale);
    //$timestamp = strftime('%G-%m-%d %H:%M:%S');

    $insert = "INSERT INTO $cfg->dbtablename(";
    $vals = ") VALUES(";
    foreach ($data as $key => $val) {
        $insert .= "$key,";
        $vals .= "'$val',";
    }
    $insert = rtrim($insert, ',');
    $vals = rtrim($vals, ',');
    $vals .= ')';
    $stmt = $insert . $vals;

    // get the DB connection
    $db = new Db();
    $result = $db->exec($stmt);

    return $result;
}


function convertEcowitt($cfg, $dataIn) {
    // example data from Waggies weatherstation:
    // POST = Array ( [PASSKEY] => B663F37A8A125F3A75C293B048EC3B2E [stationtype] => EasyWeatherV1.4.0 [dateutc] => 2019-07-18 06:46:36 [tempinf] => 61.3 [humidityin] => 65 [baromrelin] => 29.661 [baromabsin] => 29.336 [tempf] => 52.9 [humidity] => 88 [winddir] => 263 [windspeedmph] => 6.3 [windgustmph] => 10.1 [maxdailygust] => 17.4 [rainratein] => 0.000 [eventrainin] => 0.000 [hourlyrainin] => 0.000 [dailyrainin] => 0.000 [weeklyrainin] => 0.461 [monthlyrainin] => 1.252 [totalrainin] => 2.929 [solarradiation] => 46.43 [uv] => 1 [model] => WS2900 )

    $data = array(
//        'user' => $dataIn['user'],
//        'dateutc' => $dataIn['dateutc'],
        'temp' => sprintf('%.1f', (($dataIn['tempf'] - 32) * 5 / 9)),        // to C
        'tempin' => sprintf('%.1f', (($dataIn['tempinf'] - 32) * 5 / 9)),    // to C
        'humidity' => $dataIn['humidity'],
        'humidityin' => $dataIn['humidityin'],
        'baromrel' => sprintf('%.1f', ($dataIn['baromrelin'] * 33.8639)),  // to hPa
        'baromabs' => sprintf('%.1f', ($dataIn['baromabsin'] * 33.8639)),  // to hPa
        'winddir' => $dataIn['winddir'],
        'windspeed' => sprintf('%.1f', ($dataIn['windspeedmph'] * 1.609)),    // to km/h
        'windgust' => sprintf('%.1f', ($dataIn['windgustmph'] * 1.609)),      // to km/h
        'maxdailygust' => sprintf('%.1f', ($dataIn['maxdailygust'] * 1.609)), // to km/h
        'rainrate' => sprintf('%.1f', ($dataIn['rainratein'] * 25.4)),       // to mm
        'rainevent' => sprintf('%.1f', ($dataIn['eventrainin'] * 25.4)),     // to mm
        'rainhourly' => sprintf('%.1f', ($dataIn['hourlyrainin'] * 25.4)),   // to mm
        'raindaily' => sprintf('%.1f', ($dataIn['dailyrainin'] * 25.4)),     // to mm
        'rainweekly' => sprintf('%.1f', ($dataIn['weeklyrainin'] * 25.4)),   // to mm
        'rainmonthly' => sprintf('%.1f', ($dataIn['monthlyrainin'] * 25.4)), // to mm
        'raintotal' => sprintf('%.1f', ($dataIn['totalrainin'] * 25.4)),     // to mm
        'solarradiation' => sprintf('%.0f', $dataIn['solarradiation']),  // %d doesn't round up
        'uv' => $dataIn['uv'],
//        'stationid' => $dataIn['PASSKEY'],
//        'model' => $dataIn['model']
        );

    return $data;
}


function showData($cfg) {
    $useragent = $_SERVER['HTTP_USER_AGENT'];
    date_default_timezone_set($cfg->locale);
    $timestamp = strftime('%G-%m-%d %H:%M:%S');
    $page = '<p>GET = ' . print_r($_GET, TRUE) . "\n";
    $page .= '<p>POST = ' . print_r($_POST, TRUE) . "\n";
    $page .= 'IP address = ' . getIpAddress() . "\n";
    ?>
<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>Waggies Weather</title>
</head>
<body>
</b><p>Hey there useragent <b><?=$useragent?></b></p>
<p>This page is just for reporting valid weatherstation data from known weatherstations.</p>
<p>You posted at <b><?=$timestamp?></b><br>
<?=$page?></p>
<p><b>Bye bye.</b></p>
</body>
</html>
<?php
$page .= 'userageant: ' . $useragent . "\n";
    $fh = fopen('./spurious.log', 'a+');
    fwrite($fh, $page . "\n---------------------------------------------------------------\n\n");
    fclose($fh);
}

function getIpAddress() {
    //whether ip is from share internet
    if (!empty($_SERVER['HTTP_CLIENT_IP']))
    {
        $ip_address = $_SERVER['HTTP_CLIENT_IP'];
    }
    //whether ip is from proxy
    elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR']))
    {
        $ip_address = $_SERVER['HTTP_X_FORWARDED_FOR'];
    }
    //whether ip is from remote address
    else
    {
        $ip_address = $_SERVER['REMOTE_ADDR'];
    }
    return $ip_address;
}

